Ensuring that authorization data remains in sync with the business model is an important practice when using Permify.Prior to Data Bundles, it was the responsibility of the services (such as WriteData API) to structure how relations are created and deleted when actions occur on resources.With the Data Bundles, you be able to bundle and model the creation and deletion of relations and attributes when specific actions occur on resources in your applications.We believe this functionality will streamline managing authorization data as well as managing this in a central place increases visibility around certain actions/triggers that end up with data creation.
Let’s examine how Bundles operate with a basic example.Let’s say you want to model how data will be created when an organization is created in your application. For this purpose, you can utilize the WriteBundle API endpoint. This API enables users to define or update data bundles, each distinguished by a unique name.Here’s an example body for WriteBundle in this scenario:
Operations represent actions that can be performed on relationships and attributes, such as adding or deleting relationships when certain events occur.Let’s say user:564 creates an organization:789 in your application. According to your authorization logic, this will result in the creation of several authorization data, including relational tuples and attributes, respectively.
organization:789#admin@user:564
organization:789#manager@user:564
organization:789$public|boolean:false
Instead of using the WriteData endpoint, you can utilize RunBundle to create this data by simply providing specific identifiers.An example request of RunBundle for this scenario:
The “Write Bundle” API is designed for handling data in a multi-tenant application environment. Its primary function is to write and delete data according to predefined structures. This API allows users to define or update data bundles, each distinguished by a unique name.
Identifier of the tenant, if you are not using multi-tenancy (have only one tenant) use pre-inserted tenant t1 for this field. Required, and must match the pattern \“[a-zA-Z0-9-,]+\“, max 64 bytes.
Body
application/json
BundleWriteRequest is used to request the writing of a bundle.
It contains the tenant_id to identify the tenant and the Bundles object.
Identifier or acknowledgment of the written bundle.
{"docsConfig":{"theme":"mint","$schema":"https://mintlify.com/docs.json","name":"FGA Documentation","colors":{"primary":"#F58320","light":"#fb923c","dark":"#ea580c"},"logo":{"light":"https://mintcdn.com/permify/s--v0P7cOOW3QatA/logo/light.svg?fit=max\u0026auto=format\u0026n=s--v0P7cOOW3QatA\u0026q=85\u0026s=35df6af816b704ec52d1461bb85c5057","dark":"https://mintcdn.com/permify/s--v0P7cOOW3QatA/logo/dark.svg?fit=max\u0026auto=format\u0026n=s--v0P7cOOW3QatA\u0026q=85\u0026s=3cba8f1833c1058096bf4924e49f8931","href":"/"},"favicon":"https://mintcdn.com/permify/s--v0P7cOOW3QatA/favicon.png?fit=max\u0026auto=format\u0026n=s--v0P7cOOW3QatA\u0026q=85\u0026s=f88a89d54d5d30758364ce67ba61ef7f","appearance":{"default":"light","strict":false},"background":{"color":{"light":"#ffffff","dark":"#0f172a"}},"navbar":{"links":[{"href":"/docs/","label":"FusionAuth Documentation"}]},"footer":{"socials":{"twitter":"https://twitter.com/getPermify","github":"https://github.com/Permify/permify","linkedin":"https://www.linkedin.com/company/permifyco"}},"fonts":{"heading":{"family":"Inter","weight":600},"body":{"family":"Inter","weight":400}},"integrations":{"ga4":{"measurementId":"G-BSRXWHBYR1"}},"styling":{"latex":false},"navigation":{"pages":[]}},"deployment":{"deploymentMetadataValue":{"subdomain":"permify","hasAudioNarration":false,"actualSubdomain":"permify","customDomains":["proxy-docs.permify.co"],"gitSource":{"type":"github","owner":"permify","repo":"permify","deployBranch":"master","contentDirectory":"docs","isPrivate":false,"mountPath":"","label":""},"chroma":{"liveDeploymentHistoryId":"6ac93fe89fc187d74aef743c","collectionId":"84e2b1d9-d591-4fff-bec3-0e97ed69fcc7","schemaVersion":"v3","latestBuiltDeploymentHistoryId":"6ac93fe89fc187d74aef743c"},"entitlements":{},"buildId":"6ac94f72a62963626e080c1f","clientVersion":"0.0.3965","searchFilterCounts":[{"language":"default","tag":"FGA Documentation","count":57},{"language":"default","tag":"API References","count":24},{"language":"default","tag":"Getting Started","count":12},{"language":"default","tag":"Setting Up","count":12},{"language":"default","tag":"Deployment","count":11},{"language":"default","tag":"Modeling Guides","count":10},{"language":"default","tag":"Permission Service","count":7},{"language":"default","tag":"Real World Examples","count":7},{"language":"default","tag":"Operations","count":6},{"language":"default","tag":"Use Cases","count":6}]},"assistantConfig":{},"hasChatPermissions":false,"hasWebMcpPermissions":false,"toggles":[{"name":"kill-isr","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"agent-mintlify-slack","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"editor-v7-file-tree","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"agent-integrations-settings","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"automations-pr-grouping","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"custom-prefix","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"analytics-v7","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"user-flows-analytics","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"no-publish-flow","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workos-onboarding","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"llms-txt-v2","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"pause-universal-search-reconcile","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"snapshot-serving-live","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"stripTemperatureMiddleware","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"per-site-search-delta","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"support-platform-pylon-zendesk","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"snapshot-serving","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"instant-rollback","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"granular-notifications-server","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"granular-notifications","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"editor-private-page-search","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"automations-fable","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"fixed-ai-action-pricing","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"automation-resolve-merge-conflict","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"scoped-publishing","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"mintql","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"page-level-analytics","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"editor-version-history-v2","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"editor-nav-generations","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"billing-page-v2","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workspace-projects","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"assistant-v5","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"byok-sep-25","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"fork-pr-previews","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"revalidation-jwt","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"vite-origin","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"editor-agent-model-picker","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"billing-updated-9-15","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"hobby-abuse-scan","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"dashboard-inbox","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false}],"isAtlas":false,"googleFontsInlined":false},"customCss":[{"filePath":"custom.css","content":"/* cyrillic-ext */\n@font-face {\n font-family: 'Inter';\n font-style: normal;\n font-weight: 100 900;\n font-display: swap;\n src: url(/_mintlify/assets/fonts/google/s/inter/v20/UcC73FwrK3iLTeHuS_nVMrMxCp50SjIa2JL7SUc.woff2) format('woff2');\n unicode-range: U+0460-052F, U+1C80-1C8A, U+20B4, U+2DE0-2DFF, U+A640-A69F, U+FE2E-FE2F;\n}\n/* cyrillic */\n@font-face {\n font-family: 'Inter';\n font-style: normal;\n font-weight: 100 900;\n font-display: swap;\n src: url(/_mintlify/assets/fonts/google/s/inter/v20/UcC73FwrK3iLTeHuS_nVMrMxCp50SjIa0ZL7SUc.woff2) format('woff2');\n unicode-range: U+0301, U+0400-045F, U+0490-0491, U+04B0-04B1, U+2116;\n}\n/* greek-ext */\n@font-face {\n font-family: 'Inter';\n font-style: normal;\n font-weight: 100 900;\n font-display: swap;\n src: url(/_mintlify/assets/fonts/google/s/inter/v20/UcC73FwrK3iLTeHuS_nVMrMxCp50SjIa2ZL7SUc.woff2) format('woff2');\n unicode-range: U+1F00-1FFF;\n}\n/* greek */\n@font-face {\n font-family: 'Inter';\n font-style: normal;\n font-weight: 100 900;\n font-display: swap;\n src: url(/_mintlify/assets/fonts/google/s/inter/v20/UcC73FwrK3iLTeHuS_nVMrMxCp50SjIa1pL7SUc.woff2) format('woff2');\n unicode-range: U+0370-0377, U+037A-037F, U+0384-038A, U+038C, U+038E-03A1, U+03A3-03FF;\n}\n/* vietnamese */\n@font-face {\n font-family: 'Inter';\n font-style: normal;\n font-weight: 100 900;\n font-display: swap;\n src: url(/_mintlify/assets/fonts/google/s/inter/v20/UcC73FwrK3iLTeHuS_nVMrMxCp50SjIa2pL7SUc.woff2) format('woff2');\n unicode-range: U+0102-0103, U+0110-0111, U+0128-0129, U+0168-0169, U+01A0-01A1, U+01AF-01B0, U+0300-0301, U+0303-0304, U+0308-0309, U+0323, U+0329, U+1EA0-1EF9, U+20AB;\n}\n/* latin-ext */\n@font-face {\n font-family: 'Inter';\n font-style: normal;\n font-weight: 100 900;\n font-display: swap;\n src: url(/_mintlify/assets/fonts/google/s/inter/v20/UcC73FwrK3iLTeHuS_nVMrMxCp50SjIa25L7SUc.woff2) format('woff2');\n unicode-range: U+0100-02BA, U+02BD-02C5, U+02C7-02CC, U+02CE-02D7, U+02DD-02FF, U+0304, U+0308, U+0329, U+1D00-1DBF, U+1E00-1E9F, U+1EF2-1EFF, U+2020, U+20A0-20AB, U+20AD-20C4, U+2113, U+2C60-2C7F, U+A720-A7FF;\n}\n/* latin */\n@font-face {\n font-family: 'Inter';\n font-style: normal;\n font-weight: 100 900;\n font-display: swap;\n src: url(/_mintlify/assets/fonts/google/s/inter/v20/UcC73FwrK3iLTeHuS_nVMrMxCp50SjIa1ZL7.woff2) format('woff2');\n unicode-range: U+0000-00FF, U+0131, U+0152-0153, U+02BB-02BC, U+02C6, U+02DA, U+02DC, U+0304, U+0308, U+0329, U+2000-206F, U+20AC, U+2122, U+2191, U+2193, U+2212, U+2215, U+FEFF, U+FFFD;\n}\n*,::after,::before{font-family:'Inter',-apple-system,BlinkMacSystemFont,'Segoe UI',system-ui,sans-serif!important}code,kbd,pre,samp,tt{font-family:'JetBrains Mono','Fira Code','Menlo','Monaco','Consolas',monospace!important}html:not(.dark) span#background-color{background:0 0!important}html:not(.dark){background-color:#fff!important;background-image:radial-gradient(768px at right top,rgba(199,210,254,.65) 0,#fff 80%),linear-gradient(rgba(99,102,241,.4) 1px,transparent 1px),linear-gradient(90deg,rgba(99,102,241,.4) 1px,transparent 1px)!important;background-size:100% 30000px,34px 34px,34px 34px!important;background-position:0 0,0 0,0 0!important;background-repeat:no-repeat,repeat,repeat!important;background-attachment:local,local,local!important}:root{--fa-orange:#F58320;--fa-orange-light:#fb923c;--fa-orange-dark:#ea580c;--fa-slate-800:#1e293b;--fa-slate-700:#334155;--fa-slate-100:#F1F5F9;--fa-slate-200:#E2E8F0}#banner{background-color:var(--fa-slate-800)!important;border-bottom:2px solid var(--fa-orange)!important}#banner a{color:var(--fa-orange-light)!important;text-decoration:underline!important}#banner,#banner a:hover{color:#fff!important}#navbar{background-color:#0f172a!important;border-bottom:1px solid #334155!important}#navbar #navbar-transition{background-color:transparent!important}#navbar a,#navbar button:hover{color:#e2e8f0!important}#navbar a:hover,#navbar li.navbar-link a:hover{color:var(--fa-orange-light)!important}#navbar li.navbar-link a{color:#fff!important;font-size:.875rem!important;font-weight:600!important;letter-spacing:-.01em!important;opacity:1!important}#navbar button{color:#94a3b8!important}#navbar a[data-slot=context-menu-trigger]{display:inline-flex!important;align-items:center!important}#navbar a[data-slot=context-menu-trigger] img{height:3rem!important;width:auto!important;order:1}#navbar a[data-slot=context-menu-trigger]::before{content:\"/\";color:#64748b;font-size:1.5rem;font-weight:300;margin-left:.75rem;margin-right:.375rem;line-height:1;order:2}#navbar a[data-slot=context-menu-trigger]::after{content:\"FGA Docs\";color:#fff;font-size:1.5rem;font-weight:700;letter-spacing:-.025em;line-height:1;order:3}[data-testid=sidebar] a[aria-current=page],aside a[aria-current=page]{border-left:3px solid var(--fa-orange)!important;color:var(--fa-orange-dark)!important;font-weight:600!important;background-color:rgba(245,131,32,.06)!important}[data-testid=sidebar] h3,aside h3{color:var(--fa-slate-800)!important;text-transform:uppercase!important;font-size:.7rem!important;letter-spacing:.06em!important;font-weight:700!important}:is(.dark) [data-testid=sidebar] h3,:is(.dark) aside h3{color:var(--fa-slate-200)!important}[data-testid=sidebar] a,aside a{color:var(--fa-slate-700)!important;transition:color .15s ease!important}[data-testid=sidebar] a:hover,aside a:hover{color:var(--fa-orange)!important}:is(.dark) [data-testid=sidebar] a,:is(.dark) aside a{color:#cbd5e1!important}:is(.dark) [data-testid=sidebar] a:hover,:is(.dark) aside a:hover{color:var(--fa-orange-light)!important}.cta-button,[data-testid=cta-button],a[class*=Button],button[class*=primary]{background-color:var(--fa-orange)!important;border-color:var(--fa-orange)!important;color:#fff!important;border-radius:6px!important;transition:background-color .15s ease!important}.cta-button:hover,[data-testid=cta-button]:hover,a[class*=Button]:hover,button[class*=primary]:hover{background-color:var(--fa-orange-dark)!important;border-color:var(--fa-orange-dark)!important}.prose a,article a,main a:not([class]){color:var(--fa-orange-dark)!important;text-decoration-color:rgba(245,131,32,.3)!important}.prose a:hover,article a:hover,main a:not([class]):hover{color:var(--fa-orange)!important;text-decoration-color:var(--fa-orange)!important}:is(.dark) .prose a,:is(.dark) article a,:is(.dark) main a:not([class]){color:var(--fa-orange-light)!important}[class*=AnchorCard],[class*=anchor-card]{border:1px solid var(--fa-slate-200)!important;border-radius:8px!important;transition:border-color .15s ease,box-shadow .15s ease!important}[class*=AnchorCard]:hover,[class*=anchor-card]:hover{border-color:var(--fa-orange)!important;box-shadow:0 2px 8px rgba(245,131,32,.12)!important}.prose h1,.prose h2,.prose h3,article h1,article h2,article h3{color:var(--fa-slate-800)!important}:is(.dark) .prose h1,:is(.dark) .prose h2,:is(.dark) .prose h3,:is(.dark) article h1,:is(.dark) article h2,:is(.dark) article h3{color:#f1f5f9!important}code,pre{border-radius:6px!important}pre{background-color:#1f273b!important}:is(.dark) pre{background-color:#00081a!important}:not(pre)>code{background-color:#f1f5f9!important;color:var(--fa-slate-800)!important;padding:.15em .4em!important;border-radius:4px!important;font-size:.875em!important}:is(.dark) :not(pre)>code{background-color:#1e293b!important;color:#e2e8f0!important}table th{background-color:var(--fa-slate-800)!important;color:#fff!important;font-weight:600!important}:is(.dark) table th{background-color:#0f172a!important}table tr:nth-child(even){background-color:rgba(241,245,249,.5)!important}:is(.dark) table tr:nth-child(even){background-color:rgba(30,41,59,.3)!important}[role=tab][aria-selected=true]{color:var(--fa-orange)!important;border-bottom-color:var(--fa-orange)!important}::-webkit-scrollbar{width:6px;height:6px}::-webkit-scrollbar-thumb{background:#94a3b8;border-radius:3px}::-webkit-scrollbar-track{background:0 0}::selection{background-color:rgba(245,131,32,.2);color:inherit}[class*=Feedback] button:hover,[class*=feedback] button:hover{color:var(--fa-orange)!important}[class*=Badge],[class*=badge]{border-radius:4px!important}[class*=highlight],mark{background-color:rgba(245,131,32,.15)!important}[class*=Card],[class*=card]{border-radius:8px!important}"}],"page":{"pagePath":"api-reference/bundle/write-bundle","slug":"/api-reference/bundle/write-bundle","pageMetadata":{"title":"Write Bundle","openapi":"post /v1/tenants/{tenant_id}/bundle/write","description":null,"href":"/api-reference/bundle/write-bundle"},"pageType":"default","mdx":{"mdxSource":{"compiledSource":"\"use strict\";const{Fragment:_Fragment,jsx:_jsx,jsxs:_jsxs}=arguments[0];const{useMDXComponents:_provideComponents}=arguments[0];function _createMdxContent(props){const _components={a:`a`,code:`code`,li:`li`,p:`p`,pre:`pre`,span:`span`,ul:`ul`,..._provideComponents(),...props.components},{CodeBlock,Heading}=_components;if(!CodeBlock)_missingMdxReference(`CodeBlock`,true);if(!Heading)_missingMdxReference(`Heading`,true);return _jsxs(_Fragment,{children:[_jsx(Heading,{level:`2`,id:`what-is-data-bundles`,children:`What is Data Bundles?`}),`\n`,_jsx(_components.p,{children:`Ensuring that authorization data remains in sync with the business model is an important practice when using Permify.`}),`\n`,_jsxs(_components.p,{children:[`Prior to Data Bundles, it was the responsibility of the services (such as `,_jsx(_components.a,{href:`/api-reference/data/write-data`,children:`WriteData API`}),`) to structure how relations are created and deleted when actions occur on resources.`]}),`\n`,_jsx(_components.p,{children:`With the Data Bundles, you be able to bundle and model the creation and deletion of relations and attributes when specific actions occur on resources in your applications.`}),`\n`,_jsx(_components.p,{children:`We believe this functionality will streamline managing authorization data as well as managing this in a central place increases visibility around certain actions/triggers that end up with data creation.`}),`\n`,_jsx(Heading,{level:`2`,id:`how-bundles-work`,children:`How Bundles Work`}),`\n`,_jsx(_components.p,{children:`Let’s examine how Bundles operate with a basic example.`}),`\n`,_jsx(_components.p,{children:`Let’s say you want to model how data will be created when an organization is created in your application. For this purpose, you can utilize the WriteBundle API endpoint. This API enables users to define or update data bundles, each distinguished by a unique name.`}),`\n`,_jsx(_components.p,{children:`Here’s an example body for WriteBundle in this scenario:`}),`\n`,_jsx(CodeBlock,{filename:``,numberOfLines:`20`,language:`json`,children:_jsx(_components.pre,{className:`shiki shiki-themes github-light-default dark-plus`,style:{backgroundColor:`#ffffff`,\"--shiki-dark-bg\":`#0B0C0E`,color:`#1f2328`,\"--shiki-dark\":`#D4D4D4`},language:`json`,children:_jsxs(_components.code,{language:`json`,numberOfLines:`20`,children:[_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#0A3069`,\"--shiki-dark\":`#CE9178`},children:`\"bundles\"`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`: [`})]}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:` {`})}),`\n`,_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#116329`,\"--shiki-dark\":`#9CDCFE`},children:` \"name\"`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`: `}),_jsx(_components.span,{style:{color:`#0A3069`,\"--shiki-dark\":`#CE9178`},children:`\"organization_created\"`})]}),`\n`,_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#0A3069`,\"--shiki-dark\":`#CE9178`},children:` \"arguments\"`}),_jsx(_components.span,{style:{color:`#82071E`,\"--shiki-light-font-style\":`italic`,\"--shiki-dark\":`#F44747`,\"--shiki-dark-font-style\":`inherit`},children:`:`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:` [`})]}),`\n`,_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#0A3069`,\"--shiki-dark\":`#CE9178`},children:` \"creatorID\"`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`,`})]}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{style:{color:`#0A3069`,\"--shiki-dark\":`#CE9178`},children:` \"organizationID\"`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:` ],`})}),`\n`,_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#116329`,\"--shiki-dark\":`#9CDCFE`},children:` \"operations\"`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`: [`})]}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:` {`})}),`\n`,_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#116329`,\"--shiki-dark\":`#9CDCFE`},children:` \"relationships_write\"`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`: [`})]}),`\n`,_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#0A3069`,\"--shiki-dark\":`#CE9178`},children:` \"organization:{{.organizationID}}#admin@user:{{.creatorID}}\"`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`,`})]}),`\n`,_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#0A3069`,\"--shiki-dark\":`#CE9178`},children:` \"organization:{{.organizationID}}#manager@user:{{.creatorID}}\"`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`,`})]}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:` ],`})}),`\n`,_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#116329`,\"--shiki-dark\":`#9CDCFE`},children:` \"attributes_write\"`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`: [`})]}),`\n`,_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#0A3069`,\"--shiki-dark\":`#CE9178`},children:` \"organization:{{.organizationID}}$public|boolean:false\"`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`,`})]}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:` ],`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:` },`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:` ],`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:` },`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`],`})}),`\n`]})})}),`\n`,_jsx(_components.p,{children:`Operations represent actions that can be performed on relationships and attributes, such as adding or deleting relationships when certain events occur.`}),`\n`,_jsx(_components.p,{children:`Let’s say user:564 creates an organization:789 in your application. According to your authorization logic, this will result in the creation of several authorization data, including relational tuples and attributes, respectively.`}),`\n`,_jsxs(_components.ul,{children:[`\n`,_jsx(_components.li,{children:`organization:789#admin@user:564`}),`\n`,_jsx(_components.li,{children:`organization:789#manager@user:564`}),`\n`,_jsx(_components.li,{children:`organization:789$public|boolean:false`}),`\n`]}),`\n`,_jsxs(_components.p,{children:[`Instead of using the `,_jsx(_components.a,{href:`/api-reference/data/write-data`,children:`WriteData`}),` endpoint, you can utilize `,_jsx(_components.a,{href:`/api-reference/data/run-bundle`,children:`RunBundle`}),` to create this data by simply providing specific identifiers.`]}),`\n`,_jsxs(_components.p,{children:[`An example request of `,_jsx(_components.a,{href:`/api-reference/data/run-bundle`,children:`RunBundle`}),` for this scenario:`]}),`\n`,_jsx(CodeBlock,{filename:``,numberOfLines:`9`,language:`json`,children:_jsx(_components.pre,{className:`shiki shiki-themes github-light-default dark-plus`,style:{backgroundColor:`#ffffff`,\"--shiki-dark-bg\":`#0B0C0E`,color:`#1f2328`,\"--shiki-dark\":`#D4D4D4`},language:`json`,children:_jsxs(_components.code,{language:`json`,numberOfLines:`9`,children:[_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`POST /bundle`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`BODY`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`{`})}),`\n`,_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#116329`,\"--shiki-dark\":`#9CDCFE`},children:` \"name\"`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`: `}),_jsx(_components.span,{style:{color:`#0A3069`,\"--shiki-dark\":`#CE9178`},children:`\"project_created\"`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`,`})]}),`\n`,_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#116329`,\"--shiki-dark\":`#9CDCFE`},children:` \"arguments\"`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`: {`})]}),`\n`,_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#116329`,\"--shiki-dark\":`#9CDCFE`},children:` \"creatorID\"`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`: `}),_jsx(_components.span,{style:{color:`#0A3069`,\"--shiki-dark\":`#CE9178`},children:`\"564\"`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`,`})]}),`\n`,_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#116329`,\"--shiki-dark\":`#9CDCFE`},children:` \"organizationID\"`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`: `}),_jsx(_components.span,{style:{color:`#0A3069`,\"--shiki-dark\":`#CE9178`},children:`\"789\"`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`,`})]}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:` }`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`}`})}),`\n`]})})}),`\n`,_jsx(_components.p,{children:`This will result in the creation of the following data in Permify:`}),`\n`,_jsxs(_components.ul,{children:[`\n`,_jsx(_components.li,{children:`organization:789#admin@user:564`}),`\n`,_jsx(_components.li,{children:`organization:789#manager@user:564`}),`\n`,_jsx(_components.li,{children:`organization:789$public|boolean:false`}),`\n`]}),`\n`,_jsx(Heading,{level:`2`,id:`endpoints`,children:`Endpoints`}),`\n`,_jsxs(_components.ul,{children:[`\n`,_jsx(_components.li,{children:_jsx(_components.a,{href:`/api-reference/bundle/write-bundle`,children:`WriteBundle`})}),`\n`,_jsx(_components.li,{children:_jsx(_components.a,{href:`/api-reference/data/run-bundle`,children:`RunBundle`})}),`\n`,_jsx(_components.li,{children:_jsx(_components.a,{href:`/api-reference/bundle/delete-bundle`,children:`DeleteBundle`})}),`\n`,_jsx(_components.li,{children:_jsx(_components.a,{href:`/api-reference/bundle/read-bundle`,children:`ReadBundle`})}),`\n`]}),`\n`,_jsx(Heading,{level:`2`,id:`write-bundles-request`,children:`Write Bundles Request`}),`\n`,_jsx(_components.p,{children:`The “Write Bundle” API is designed for handling data in a multi-tenant application environment. Its primary function is to write and delete data according to predefined structures. This API allows users to define or update data bundles, each distinguished by a unique name.`})]})}function MDXContent(props={}){const{wrapper:MDXLayout}={..._provideComponents(),...props.components};return MDXLayout?_jsx(MDXLayout,{...props,children:_jsx(_createMdxContent,{...props})}):_createMdxContent(props)}return{default:MDXContent};function _missingMdxReference(id,component){throw new Error(`Expected `+(component?`component`:`object`)+\" `\"+id+\"` to be defined: you likely forgot to import, pass, or provide it.\")}","frontmatter":{},"scope":{"config":{},"pageMetadata":{"title":"Write Bundle","openapi":"post /v1/tenants/{tenant_id}/bundle/write","description":null,"href":"/api-reference/bundle/write-bundle"}}},"mdxSourceWithNoJs":null},"mdxExtracts":{"tableOfContents":[{"title":"What is Data Bundles?","slug":"what-is-data-bundles","depth":2,"children":[]},{"title":"How Bundles Work","slug":"how-bundles-work","depth":2,"children":[]},{"title":"Endpoints","slug":"endpoints","depth":2,"children":[]},{"title":"Write Bundles Request","slug":"write-bundles-request","depth":2,"children":[]}],"codeExamples":{}},"jsLinks":["/_mintlify/custom/permify/03abf5c771cc7674/gurubase.js"],"openApiReferenceData":{"operation":{"summary":"write bundle","operationId":"bundle.write","responses":{"200":"ea017da1-e85b-43c8-a3e7-b3ae152f947b","default":"a34068f0-20f8-4a4a-badc-d467c77eb365"},"parameters":["d5a1f82c-9f69-4fa9-8204-af16448d9c29"],"requestBody":"db00ec75-dd8c-4a7c-b363-f7ba06c476ca","tags":["Bundle"],"x-codeSamples":[{"label":"go","lang":"go","source":"rr, err := client.Bundle.Write(context.Background(), \u0026v1.BundleWriteRequest{\n TenantId: \"t1\",\n Bundles: []*v1.DataBundle{\n {\n Name: \"organization_created\",\n Arguments: []string{\n \"creatorID\",\n \"organizationID\",\n },\n Operations: []*v1.Operation{\n {\n RelationshipsWrite: []string{\n \"organization:{{.organizationID}}#admin@user:{{.creatorID}}\",\n \"organization:{{.organizationID}}#manager@user:{{.creatorID}}\",\n },\n AttributesWrite: []string{\n \"organization:{{.organizationID}}$public|boolean:false\",\n },\n },\n },\n },\n },\n})"},{"label":"node","lang":"javascript","source":"client.bundle.write({\n tenantId: \"t1\",\n bundles: [\n {\n name: \"organization_created\",\n arguments: [\n \"creatorID\",\n \"organizationID\",\n ],\n operations: [\n {\n relationships_write: [\n \"organization:{{.organizationID}}#admin@user:{{.creatorID}}\",\n \"organization:{{.organizationID}}#manager@user:{{.creatorID}}\",\n ],\n attributes_write: [\n \"organization:{{.organizationID}}$public|boolean:false\",\n ]\n }\n ]\n }\n ]\n}).then((response) => {\n // handle response\n})"},{"label":"cURL","lang":"curl","source":"curl --location --request POST 'localhost:3476/v1/tenants/{tenant_id}/bundle/write' \\\n--header 'Content-Type: application/json' \\\n--data-raw '{\n \"bundles\": [\n {\n \"name\": \"organization_created\",\n \"arguments\": [\n \"creatorID\",\n \"organizationID\"\n ],\n \"operations\": [\n {\n \"relationships_write\": [\n \"organization:{{.organizationID}}#admin@user:{{.creatorID}}\",\n \"organization:{{.organizationID}}#manager@user:{{.creatorID}}\"\n ],\n \"attributes_write\": [\n \"organization:{{.organizationID}}$public|boolean:false\"\n ]\n }\n ]\n }\n ]\n}'"}],"method":"post","type":"path","servers":[],"security":[],"path":"/v1/tenants/{tenant_id}/bundle/write","baseUrlOptions":[],"title":"write bundle","description":"","codeSamples":[{"label":"go","lang":"go","source":"rr, err := client.Bundle.Write(context.Background(), \u0026v1.BundleWriteRequest{\n TenantId: \"t1\",\n Bundles: []*v1.DataBundle{\n {\n Name: \"organization_created\",\n Arguments: []string{\n \"creatorID\",\n \"organizationID\",\n },\n Operations: []*v1.Operation{\n {\n RelationshipsWrite: []string{\n \"organization:{{.organizationID}}#admin@user:{{.creatorID}}\",\n \"organization:{{.organizationID}}#manager@user:{{.creatorID}}\",\n },\n AttributesWrite: []string{\n \"organization:{{.organizationID}}$public|boolean:false\",\n },\n },\n },\n },\n },\n})"},{"label":"node","lang":"javascript","source":"client.bundle.write({\n tenantId: \"t1\",\n bundles: [\n {\n name: \"organization_created\",\n arguments: [\n \"creatorID\",\n \"organizationID\",\n ],\n operations: [\n {\n relationships_write: [\n \"organization:{{.organizationID}}#admin@user:{{.creatorID}}\",\n \"organization:{{.organizationID}}#manager@user:{{.creatorID}}\",\n ],\n attributes_write: [\n \"organization:{{.organizationID}}$public|boolean:false\",\n ]\n }\n ]\n }\n ]\n}).then((response) => {\n // handle response\n})"},{"label":"cURL","lang":"curl","source":"curl --location --request POST 'localhost:3476/v1/tenants/{tenant_id}/bundle/write' \\\n--header 'Content-Type: application/json' \\\n--data-raw '{\n \"bundles\": [\n {\n \"name\": \"organization_created\",\n \"arguments\": [\n \"creatorID\",\n \"organizationID\"\n ],\n \"operations\": [\n {\n \"relationships_write\": [\n \"organization:{{.organizationID}}#admin@user:{{.creatorID}}\",\n \"organization:{{.organizationID}}#manager@user:{{.creatorID}}\"\n ],\n \"attributes_write\": [\n \"organization:{{.organizationID}}$public|boolean:false\"\n ]\n }\n ]\n }\n ]\n}'"}],"requiredOnlyExamples":false,"requestExampleType":"codeSamples","responseExampleType":"generated"},"dependencies":{"parameters":{"d5a1f82c-9f69-4fa9-8204-af16448d9c29":{"name":"tenant_id","description":"Identifier of the tenant, if you are not using multi-tenancy (have only one tenant) use pre-inserted tenant \u003ccode>t1\u003c/code> for this field. Required, and must match the pattern \\“[a-zA-Z0-9-,]+\\“, max 64 bytes.","in":"path","required":true,"schema":{"type":"string","isRequired":true,"description":"Identifier of the tenant, if you are not using multi-tenancy (have only one tenant) use pre-inserted tenant \u003ccode>t1\u003c/code> for this field. Required, and must match the pattern \\“[a-zA-Z0-9-,]+\\“, max 64 bytes.","uniqueKey":"","typeLabel":"string"}}},"requestBody":{"content":{"application/json":{"schema":{"type":"object","properties":{"bundles":{"type":"array","items":{"type":"object","properties":{"name":{"type":"string","description":"'name' is a simple string field representing the name of the DataBundle.","uniqueKey":"bundles.items.[INDEX].name","typeLabel":"string"},"arguments":{"type":"array","items":{"type":"string","uniqueKey":"bundles.items.[INDEX].arguments.items.[INDEX]","typeLabel":"string"},"description":"'arguments' is a repeated field, which means it can contain multiple strings.\nThese are used to store a list of arguments related to the DataBundle.","uniqueKey":"bundles.items.[INDEX].arguments","typeLabel":"string[]"},"operations":{"type":"array","items":{"type":"object","properties":{"relationships_write":{"type":"array","items":{"type":"string","uniqueKey":"bundles.items.[INDEX].operations.items.[INDEX].relationships_write.items.[INDEX]","typeLabel":"string"},"description":"'relationships_write' is a repeated string field for storing relationship keys\nthat are to be written or created.","uniqueKey":"bundles.items.[INDEX].operations.items.[INDEX].relationships_write","typeLabel":"string[]"},"relationships_delete":{"type":"array","items":{"type":"string","uniqueKey":"bundles.items.[INDEX].operations.items.[INDEX].relationships_delete.items.[INDEX]","typeLabel":"string"},"description":"'relationships_delete' is a repeated string field for storing relationship keys\nthat are to be deleted or removed.","uniqueKey":"bundles.items.[INDEX].operations.items.[INDEX].relationships_delete","typeLabel":"string[]"},"attributes_write":{"type":"array","items":{"type":"string","uniqueKey":"bundles.items.[INDEX].operations.items.[INDEX].attributes_write.items.[INDEX]","typeLabel":"string"},"description":"'attributes_write' is a repeated string field for storing attribute keys\nthat are to be written or created.","uniqueKey":"bundles.items.[INDEX].operations.items.[INDEX].attributes_write","typeLabel":"string[]"},"attributes_delete":{"type":"array","items":{"type":"string","uniqueKey":"bundles.items.[INDEX].operations.items.[INDEX].attributes_delete.items.[INDEX]","typeLabel":"string"},"description":"'attributes_delete' is a repeated string field for storing attribute keys\nthat are to be deleted or removed.","uniqueKey":"bundles.items.[INDEX].operations.items.[INDEX].attributes_delete","typeLabel":"string[]"}},"description":"Operation is a message representing a series of operations that can be performed.\nIt includes fields for writing and deleting relationships and attributes.","uniqueKey":"bundles.items.[INDEX].operations.items.[INDEX]","typeLabel":"object"},"description":"'operations' is a repeated field containing multiple Operation messages.\nEach Operation represents a specific action or set of actions to be performed.","uniqueKey":"bundles.items.[INDEX].operations","typeLabel":"object[]"}},"description":"DataBundle is a message representing a bundle of data, which includes a name,\na list of arguments, and a series of operations.","uniqueKey":"bundles.items.[INDEX]","typeLabel":"object"},"description":"Contains the bundle data to be written.","uniqueKey":"bundles","typeLabel":"object[]"}},"description":"BundleWriteRequest is used to request the writing of a bundle.\nIt contains the tenant_id to identify the tenant and the Bundles object.","uniqueKey":"","typeLabel":"object"},"examples":{"Example":{"title":"Example","value":{"bundles":[{"name":"\u003cstring>","arguments":["\u003cstring>"],"operations":[{"relationships_write":["\u003cstring>"],"relationships_delete":["\u003cstring>"],"attributes_write":["\u003cstring>"],"attributes_delete":["\u003cstring>"]}]}]}}},"exampleType":"generated"}},"required":true,"exampleType":"generated"},"responses":{"ea017da1-e85b-43c8-a3e7-b3ae152f947b":{"description":"A successful response.","content":{"application/json":{"schema":{"type":"object","properties":{"names":{"type":"array","items":{"type":"string","uniqueKey":"names.items.[INDEX]","typeLabel":"string"},"description":"Identifier or acknowledgment of the written bundle.","uniqueKey":"names","typeLabel":"string[]"}},"description":"BundleWriteResponse is the response for a BundleWriteRequest.\nIt includes a name which could be used as an identifier or acknowledgment.","uniqueKey":"","typeLabel":"object"},"examples":{"Example":{"title":"Example","value":{"names":["\u003cstring>"]}}},"exampleType":"generated"}},"exampleType":"generated"},"a34068f0-20f8-4a4a-badc-d467c77eb365":{"description":"An unexpected error response.","content":{"application/json":{"schema":{"type":"object","properties":{"code":{"type":"integer","format":"int32","uniqueKey":"code","typeLabel":"integer\u003cint32>"},"message":{"type":"string","uniqueKey":"message","typeLabel":"string"},"details":{"type":"array","items":{"type":"object","properties":{"@type":{"type":"string","description":"A URL/resource name that uniquely identifies the type of the serialized\nprotocol buffer message. This string must contain at least\none \"/\" character. The last segment of the URL's path must represent\nthe fully qualified name of the type (as in\n`path/google.protobuf.Duration`). The name should be in a canonical form\n(e.g., leading \".\" is not accepted).\n\nIn practice, teams usually precompile into the binary all types that they\nexpect it to use in the context of Any. However, for URLs which use the\nscheme `http`, `https`, or no scheme, one can optionally set up a type\nserver that maps type URLs to message definitions as follows:\n\n* If no scheme is provided, `https` is assumed.\n* An HTTP GET on the URL must yield a [google.protobuf.Type][]\n value in binary format, or produce an error.\n* Applications are allowed to cache lookup results based on the\n URL, or have them precompiled into a binary to avoid any\n lookup. Therefore, binary compatibility needs to be preserved\n on changes to types. (Use versioned type names to manage\n breaking changes.)\n\nNote: this functionality is not currently available in the official\nprotobuf release, and it is not used for type URLs beginning with\ntype.googleapis.com. As of May 2023, there are no widely used type server\nimplementations and no plans to implement one.\n\nSchemes other than `http`, `https` (or the empty scheme) might be\nused with implementation specific semantics.","uniqueKey":"details.items.[INDEX].@type","typeLabel":"string"}},"additionalProperties":{"oneOf":[{}],"uniqueKey":"details.items.[INDEX].additionalProperties","typeLabel":"any"},"description":"`Any` contains an arbitrary serialized protocol buffer message along with a\nURL that describes the type of the serialized message.\n\nProtobuf library provides support to pack/unpack Any values in the form\nof utility functions or additional generated methods of the Any type.\n\nExample 1: Pack and unpack a message in C++.\n\n Foo foo = ...;\n Any any;\n any.PackFrom(foo);\n ...\n if (any.UnpackTo(\u0026foo)) {\n ...\n }\n\nExample 2: Pack and unpack a message in Java.\n\n Foo foo = ...;\n Any any = Any.pack(foo);\n ...\n if (any.is(Foo.class)) {\n foo = any.unpack(Foo.class);\n }\n // or ...\n if (any.isSameTypeAs(Foo.getDefaultInstance())) {\n foo = any.unpack(Foo.getDefaultInstance());\n }\n\n Example 3: Pack and unpack a message in Python.\n\n foo = Foo(...)\n any = Any()\n any.Pack(foo)\n ...\n if any.Is(Foo.DESCRIPTOR):\n any.Unpack(foo)\n ...\n\n Example 4: Pack and unpack a message in Go\n\n foo := \u0026pb.Foo{...}\n any, err := anypb.New(foo)\n if err != nil {\n ...\n }\n ...\n foo := \u0026pb.Foo{}\n if err := any.UnmarshalTo(foo); err != nil {\n ...\n }\n\nThe pack methods provided by protobuf library will by default use\n'type.googleapis.com/full.type.name' as the type URL and the unpack\nmethods only use the fully qualified type name after the last '/'\nin the type URL, for example \"foo.bar.com/x/y.z\" will yield type\nname \"y.z\".\n\nJSON\n====\nThe JSON representation of an `Any` value uses the regular\nrepresentation of the deserialized, embedded message, with an\nadditional field `@type` which contains the type URL. Example:\n\n package google.profile;\n message Person {\n string first_name = 1;\n string last_name = 2;\n }\n\n {\n \"@type\": \"type.googleapis.com/google.profile.Person\",\n \"firstName\": \u003cstring>,\n \"lastName\": \u003cstring>\n }\n\nIf the embedded message type is well-known and has a custom JSON\nrepresentation, that representation will be embedded adding a field\n`value` which holds the custom JSON in addition to the `@type`\nfield. Example (for message [google.protobuf.Duration][]):\n\n {\n \"@type\": \"type.googleapis.com/google.protobuf.Duration\",\n \"value\": \"1.212s\"\n }","uniqueKey":"details.items.[INDEX]","typeLabel":"object"},"uniqueKey":"details","typeLabel":"object[]"}},"uniqueKey":"","typeLabel":"object"},"examples":{"Example":{"title":"Example","value":{"code":123,"message":"\u003cstring>","details":[{"@type":"\u003cstring>"}]}}},"exampleType":"generated"}},"exampleType":"generated"}},"security":{},"servers":{}},"originalFileLocation":"api-reference/openapi.json"},"subdomain":"permify","siteName":"FGA Documentation","title":"Write Bundle - FGA Documentation","navMaps":{"firstHrefInVersion":{},"firstHrefInLanguage":{}},"lastModified":"2026-10-09T20:33:01.526Z","originalFileLocation":"api-reference/bundle/write-bundle.mdx"},"headHtml":"\u003cscript data-mint-head>(function(){var d=document.documentElement,p=null;if(!p){try{p=localStorage.getItem(\"isDarkMode\")}catch(e){}if(p==='true')p='dark';else if(p==='false')p='light';if(p!=='light'\u0026\u0026p!=='dark'\u0026\u0026p!=='system')p=\"light\"}var r=p==='system'?(matchMedia(\"(prefers-color-scheme: dark)\").matches?'dark':'light'):p;d.classList.remove(r==='dark'?'light':'dark');d.classList.add(r);d.setAttribute(\"data-theme-preference\",p)})();\u003c/script>\u003cmeta data-mint-head name=\"application-name\" content=\"FGA Documentation\">\u003cmeta data-mint-head name=\"generator\" content=\"Mintlify\">\u003clink data-mint-head rel=\"icon\" type=\"image/png\" sizes=\"192x192\" href=\"/mintlify-assets/_mintlify/favicons/permify/a_feQF0dT9qeMKZe/_generated/favicon/android-chrome-192x192.png\" media=\"(prefers-color-scheme: light)\">\u003clink data-mint-head rel=\"apple-touch-icon\" type=\"image/png\" sizes=\"180x180\" href=\"/mintlify-assets/_mintlify/favicons/permify/a_feQF0dT9qeMKZe/_generated/favicon/apple-touch-icon.png\">\u003clink data-mint-head rel=\"icon\" type=\"image/png\" sizes=\"16x16\" href=\"/mintlify-assets/_mintlify/favicons/permify/a_feQF0dT9qeMKZe/_generated/favicon/favicon-16x16.png\" media=\"(prefers-color-scheme: light)\">\u003clink data-mint-head rel=\"icon\" type=\"image/png\" sizes=\"32x32\" href=\"/mintlify-assets/_mintlify/favicons/permify/a_feQF0dT9qeMKZe/_generated/favicon/favicon-32x32.png\" media=\"(prefers-color-scheme: light)\">\u003clink data-mint-head rel=\"shortcut icon\" type=\"image/x-icon\" href=\"/mintlify-assets/_mintlify/favicons/permify/a_feQF0dT9qeMKZe/_generated/favicon/favicon.ico\" media=\"(prefers-color-scheme: light)\">\u003clink data-mint-head rel=\"icon\" type=\"image/png\" sizes=\"192x192\" href=\"/mintlify-assets/_mintlify/favicons/permify/a_feQF0dT9qeMKZe/_generated/favicon-dark/android-chrome-192x192.png\" media=\"(prefers-color-scheme: dark)\">\u003clink data-mint-head rel=\"icon\" type=\"image/png\" sizes=\"16x16\" href=\"/mintlify-assets/_mintlify/favicons/permify/a_feQF0dT9qeMKZe/_generated/favicon-dark/favicon-16x16.png\" media=\"(prefers-color-scheme: dark)\">\u003clink data-mint-head rel=\"icon\" type=\"image/png\" sizes=\"32x32\" href=\"/mintlify-assets/_mintlify/favicons/permify/a_feQF0dT9qeMKZe/_generated/favicon-dark/favicon-32x32.png\" media=\"(prefers-color-scheme: dark)\">\u003clink data-mint-head rel=\"shortcut icon\" type=\"image/x-icon\" href=\"/mintlify-assets/_mintlify/favicons/permify/a_feQF0dT9qeMKZe/_generated/favicon-dark/favicon.ico\" media=\"(prefers-color-scheme: dark)\">\u003cmeta data-mint-head property=\"og:title\" content=\"Write Bundle - FGA Documentation\">\u003cmeta data-mint-head property=\"og:site_name\" content=\"FGA Documentation\">\u003cmeta data-mint-head property=\"og:url\" content=\"https://proxy-docs.permify.co/api-reference/bundle/write-bundle\">\u003cmeta data-mint-head property=\"og:type\" content=\"website\">\u003cmeta data-mint-head property=\"og:image\" content=\"https://permify.mintlify.app/_mintlify/api/og/v2?division=Bundle+Service\u0026amp;title=Write+Bundle\u0026amp;theme=9be289e78f6ac24dc5c5d06f\u0026amp;signature=c61a445e31c44fcc936e863dc8433baba9c53f6056f9f816a87b3d8a30200c20\">\u003cmeta data-mint-head property=\"og:image:width\" content=\"1200\">\u003cmeta data-mint-head property=\"og:image:height\" content=\"630\">\u003cmeta data-mint-head name=\"twitter:card\" content=\"summary_large_image\">\u003cmeta data-mint-head name=\"twitter:title\" content=\"Write Bundle - FGA Documentation\">\u003cmeta data-mint-head name=\"twitter:image\" content=\"https://permify.mintlify.app/_mintlify/api/og/v2?division=Bundle+Service\u0026amp;title=Write+Bundle\u0026amp;theme=9be289e78f6ac24dc5c5d06f\u0026amp;signature=c61a445e31c44fcc936e863dc8433baba9c53f6056f9f816a87b3d8a30200c20\">\u003cmeta data-mint-head name=\"twitter:image:width\" content=\"1200\">\u003cmeta data-mint-head name=\"twitter:image:height\" content=\"630\">\u003cmeta data-mint-head name=\"msapplication-config\" content=\"/mintlify-assets/_mintlify/favicons/permify/a_feQF0dT9qeMKZe/_generated/favicon/browserconfig.xml\">\u003cmeta data-mint-head name=\"apple-mobile-web-app-title\" content=\"FGA Documentation\">\u003cmeta data-mint-head name=\"msapplication-TileColor\" content=\"#F58320\">\u003clink data-mint-head rel=\"canonical\" href=\"https://proxy-docs.permify.co/api-reference/bundle/write-bundle\">\u003clink data-mint-head rel=\"alternate\" type=\"application/xml\" href=\"/sitemap.xml\">\u003clink data-mint-head rel=\"alternate\" type=\"text/markdown\" href=\"/api-reference/bundle/write-bundle.md\">\u003cscript data-mint-head type=\"application/ld+json\">{\"@context\":\"https://schema.org\",\"@graph\":[{\"@type\":\"Organization\",\"@id\":\"https://proxy-docs.permify.co/#organization\",\"name\":\"FGA Documentation\",\"url\":\"https://proxy-docs.permify.co\",\"logo\":{\"@type\":\"ImageObject\",\"url\":\"https://mintcdn.com/permify/s--v0P7cOOW3QatA/logo/light.svg?fit=max\u0026auto=format\u0026n=s--v0P7cOOW3QatA\u0026q=85\u0026s=35df6af816b704ec52d1461bb85c5057\"}},{\"@type\":\"WebSite\",\"@id\":\"https://proxy-docs.permify.co#website\",\"name\":\"FGA Documentation\",\"url\":\"https://proxy-docs.permify.co\",\"publisher\":{\"@id\":\"https://proxy-docs.permify.co/#organization\"}},{\"@type\":\"WebPage\",\"@id\":\"https://proxy-docs.permify.co/api-reference/bundle/write-bundle#webpage\",\"url\":\"https://proxy-docs.permify.co/api-reference/bundle/write-bundle\",\"name\":\"Write Bundle\",\"dateModified\":\"2026-10-09T20:33:01.526Z\",\"isPartOf\":{\"@id\":\"https://proxy-docs.permify.co#website\"},\"breadcrumb\":{\"@id\":\"https://proxy-docs.permify.co/api-reference/bundle/write-bundle#breadcrumb\"}},{\"@type\":\"BreadcrumbList\",\"@id\":\"https://proxy-docs.permify.co/api-reference/bundle/write-bundle#breadcrumb\",\"itemListElement\":[{\"@type\":\"ListItem\",\"position\":1,\"name\":\"FGA Documentation\",\"item\":\"https://proxy-docs.permify.co\"},{\"@type\":\"ListItem\",\"position\":2,\"name\":\"Write Bundle\",\"item\":\"https://proxy-docs.permify.co/api-reference/bundle/write-bundle\"}]},{\"@type\":[\"TechArticle\",\"APIReference\"],\"@id\":\"https://proxy-docs.permify.co/api-reference/bundle/write-bundle#apireference\",\"headline\":\"Write Bundle\",\"name\":\"Write Bundle\",\"url\":\"https://proxy-docs.permify.co/api-reference/bundle/write-bundle\",\"mainEntityOfPage\":{\"@id\":\"https://proxy-docs.permify.co/api-reference/bundle/write-bundle#webpage\"},\"dateModified\":\"2026-10-09T20:33:01.526Z\",\"publisher\":{\"@id\":\"https://proxy-docs.permify.co/#organization\"},\"isPartOf\":{\"@id\":\"https://proxy-docs.permify.co#website\"}}]}\u003c/script>\u003cscript data-mint-head type=\"application/ld+json\">{\"@context\":\"https://schema.org\",\"@type\":\"WebSite\",\"name\":\"FGA Documentation\",\"creator\":{\"@type\":\"Organization\",\"name\":\"Mintlify\",\"url\":\"https://mintlify.com\"}}\u003c/script>","siteName":"FGA Documentation","nav":{"global":null,"tabs":[{"tab":"FGA Documentation","pages":[{"title":"FGA Documentation","href":"/permify-overview/intro"}]},{"tab":"API References","groups":[{"group":"API Documentation","pages":[{"title":"Introduction","href":"/api-reference/introduction"}]},{"group":"Schema Service","pages":[{"title":"Write Schema","openapi":"post /v1/tenants/{tenant_id}/schemas/write","href":"/api-reference/schema/write-schema"},{"title":"List Schema","openapi":"post /v1/tenants/{tenant_id}/schemas/list","href":"/api-reference/schema/list-schema"},{"title":"Partial Schema Update","openapi":"patch /v1/tenants/{tenant_id}/schemas/partial-write","href":"/api-reference/schema/partial-write"},{"title":"Read Schema","openapi":"post /v1/tenants/{tenant_id}/schemas/read","href":"/api-reference/schema/read-schema"}]},{"group":"Data Service","pages":[{"title":"Write Authorization Data","openapi":"post /v1/tenants/{tenant_id}/data/write","href":"/api-reference/data/write-data"},{"title":"Read Relationships","openapi":"post /v1/tenants/{tenant_id}/data/relationships/read","href":"/api-reference/data/read-relationships"},{"title":"Read Attributes","openapi":"post /v1/tenants/{tenant_id}/data/attributes/read","href":"/api-reference/data/read-attributes"},{"title":"Run Bundle","openapi":"post /v1/tenants/{tenant_id}/data/run-bundle","href":"/api-reference/data/run-bundle"},{"title":"Delete Data","openapi":"post /v1/tenants/{tenant_id}/data/delete","href":"/api-reference/data/delete-data"}]},{"group":"Permission Service","pages":[{"title":"Check Access Control","openapi":"post /v1/tenants/{tenant_id}/permissions/check","href":"/api-reference/permission/check-api"},{"title":"Bulk Check","openapi":"post /v1/tenants/{tenant_id}/permissions/bulk-check","href":"/api-reference/permission/bulk-check"},{"title":"Expand API","openapi":"post /v1/tenants/{tenant_id}/permissions/expand","href":"/api-reference/permission/expand-api"},{"title":"Subject Filtering","openapi":"post /v1/tenants/{tenant_id}/permissions/lookup-subject","href":"/api-reference/permission/lookup-subject"},{"title":"Lookup Entity (Data Filtering)","openapi":"post /v1/tenants/{tenant_id}/permissions/lookup-entity","href":"/api-reference/permission/lookup-entity"},{"title":"Lookup Entity (Streaming)","openapi":"post /v1/tenants/{tenant_id}/permissions/lookup-entity-stream","href":"/api-reference/permission/lookup-entity-stream"},{"title":"Subject Permission List","openapi":"post /v1/tenants/{tenant_id}/permissions/subject-permission","href":"/api-reference/permission/subject-permission"}]},{"group":"Tenancy Service","pages":[{"title":"List Tenants","openapi":"post /v1/tenants/list","href":"/api-reference/tenancy/list-tenants"},{"title":"Create Tenant","openapi":"post /v1/tenants/create","href":"/api-reference/tenancy/create-tenant"},{"title":"Delete Tenant","openapi":"delete /v1/tenants/{id}","description":null,"href":"/api-reference/tenancy/delete-tenant"}]},{"group":"Bundle Service","pages":[{"title":"Write Bundle","openapi":"post /v1/tenants/{tenant_id}/bundle/write","href":"/api-reference/bundle/write-bundle"},{"title":"Read Bundle","openapi":"post /v1/tenants/{tenant_id}/bundle/read","description":null,"href":"/api-reference/bundle/read-bundle"},{"title":"Delete Bundle","openapi":"post /v1/tenants/{tenant_id}/bundle/delete","href":"/api-reference/bundle/delete-bundle"}]},{"group":"Watch Service","pages":[{"title":"Watch API","openapi":"post /v1/tenants/{tenant_id}/watch","href":"/api-reference/watch/watch-changes"}]}]}]},"title":"Write Bundle - FGA Documentation","buildId":"dpl_849ArpqvBiCczQiT1Y1stNGpbqHT","deploymentId":"dpl_849ArpqvBiCczQiT1Y1stNGpbqHT","dynamics":["c2aa737661","2b790eda92","b0f84f53ff","a9bb46feb3"],"chunks":["OpenApiReferenceProvider-Bbp7I60D.js","utils-C3RIvJha.js","cloneDeep-izs3Hzxb.js","_Uint8Array-BVIqJ90l.js","isObjectLike-C8vmzPEN.js","isArray-Dcu1dQ5t.js","utils-DqD-vLt8.js","toString-BX-iyh8G.js","isSymbol-CSH9U2Gm.js","addUniqueKeysToSchema-B31Loprg.js","snippetPresets-DKpk-b8t.js","style-to-object-BY3JEAdk.js","v4-DIgz8zy6.js","ApiExamples-Cj65AhOR.js","isEqual-BfaiBbcl.js","usePlaygroundInputsStore-BXtn5gcC.js","shallow-RY2b03Cp.js","getApiPlaygroundDisplay-B0jeiPk3.js","CodeSnippet-CYgBjjwn.js","CodeSnippets-DOngDrYB.js","Page-n7I5XbKb.js","getPastedJson-DRQbJx-T.js","icon-CQiQCicY.js","MethodPill-BKTLdNtu.js","DuplicateIcon-B9jpAdat.js","createIcon-DCddRrXv.js","DynamicMarkdown-a8hUKrw6.js","SectionHeading-eECVV2eH.js","axios-vUo_bRtp.js","Markdown--GF7ZIpf.js","clsx-DZLdJUrt.js","lib--scc4DXi.js","lib-B8HbPgcC.js","html-void-elements-mCSPHezU.js","dist-2LoAhjKH.js","katex-YMM-FMeD.js","marked.esm-CZWythHk.js","AssistantPageLink-Zwc0ZncM.js"]}